<template>
  <v-app>
  <v-data-table
    v-model="selected"
    :headers="headers"
    :items="desserts"
    :single-select="singleSelect"
    item-key="REQUEST_NO"
    show-select
    style="padding:25px">

    <template v-slot:top>
      <div>
          <div>
            <v-toolbar style="box-shadow:none !important">
              <v-toolbar-title><b>{{title}}</b></v-toolbar-title>

              <v-spacer></v-spacer>
              <v-btn icon v-on:click="getMaterial">
                  <v-icon>mdi-refresh</v-icon>
                </v-btn>
            </v-toolbar>

            <div style="padding:0px 25px">
                <v-layout row>
                  <v-flex md8>
                      <v-btn rounded style="margin-top:15px" color="primary" large v-on:click="send('APP')">
                        <v-icon dark style="margin-right:10px">mdi-check-circle-outline</v-icon>
                        Approve
                      </v-btn>
                      &nbsp;
                      <v-btn rounded style="margin-top:15px" color="primary" large v-on:click="send('NI')">
                        <v-icon dark style="margin-right:10px">mdi-check-circle-outline</v-icon>
                        Need Info
                      </v-btn>
                      &nbsp;
                      <v-btn rounded style="margin-top:15px" color="error" large v-on:click="send('RJT')">
                        <v-icon dark style="margin-right:10px">mdi-close-circle-outline</v-icon>
                        Reject
                      </v-btn>
                  </v-flex>

                  <v-flex md4>
                      <v-col cols="12" sm="6" md="12">
                        <v-text-field
                          label="Solo"
                          v-model="val"
                           v-on:keyup.enter="getMaterial()"
                          placeholder="Enter Your Keywords"
                          solo
                          append-icon="search"
                        ></v-text-field>
                      </v-col>
                  </v-flex>

                </v-layout>   
            </div>
        </div>
      </div>

       <v-dialog
        v-model="modal_message"
        max-width="700px"
      >
        <v-card>
          <v-card-title>
            Message
          </v-card-title>
          <v-card-text>
              <div style="height:300px;max-height:400px;overflow-y:scroll;padding:20px">
                    <div>
                      <span>Message From Requester</span>
                      <div v-if="requester_message" style="padding:15px 20px;margin-top:10px;color:#fff;background-color:#1976d2;border-radius:10px;width:90%">
                          {{requester_message}}
                          
                          <div align="right" style="font-size:12px">{{requester_date}}</div>
                      </div>                     
                    </div>

                    <div v-if="!requester_message" style="padding:20px;margin-top:10px;background-color:#fafafa;border-radius:10px;width:90%">
                        Not Message Entry From Requester
                    </div>
                    <br>
                    <div>
                      <span>Message From Approval</span>
                      <div  v-for="message in list_message" v-bind:key="message.ID" style="padding:15px 20px;color:#fff;background-color:#1976d2;border-radius:10px;width:90%;margin-top:15px">
                          {{message.MESSAGE}}
                          
                          <div align="right" style="font-size:12px">{{message.MESSAGE_DATE}}</div>
                      </div>                     
                    </div> 
              </div>
              <div style="padding-top:5px">
                  <v-text-field
                    label="Enter Message"
                    v-model="message"
                    placeholder="Enter Message"
                    append-icon="send"
                    @click:append="sendMessage()"
                    v-on:keyup.enter="sendMessage()"
                  ></v-text-field>
              </div>
              <div align="right">
                  <v-btn
                  color="primary"
                  text
                  @click="modal_message = false"
                >
                  Close
                </v-btn>
            </div>
          </v-card-text>
        </v-card>
      </v-dialog>
    </template>

    <template v-slot:item.action="{ item }">
      <v-icon
        medium
        class="mr-2"
        v-if="!item.MESSAGE"
        @click="getMessage(item)"
      >
        email
      </v-icon>

      <v-icon
        medium
        color="primary"
        class="mr-2"
        v-if="item.MESSAGE"
        @click="getMessage(item)"
      >
        email
      </v-icon>
    </template>

  </v-data-table>
  </v-app>
</template>


<script>
export default {
    methods: {
        getMaterial(){
          var token = atob(this.$route.params.token);
          var arr = token.split("&")
          var self = this;
          var val  = self.val;
          var url  = self.base_url + "search/item_approval";
          var server = "";

          self.user_id = arr[0]; 
          self.user_request = arr[2];
          self.departement_id = arr[1];
          self.user_approval_request = arr[3];
          self.item_status = arr[6];

          if(self.item_status=='APP2'){
              server = arr[7];
          }
          
          this.axios.post(url , {
              param : val,
              user_id : arr[0],
              status  : self.item_status,
              departement_id : arr[1],
              server : server
          })
          .then(function (response) {
              self.desserts = response.data;
          });
      },

      send(type=''){      
            var self = this;
            var url = this.base_url + 'material/submit';
            var arritem = self.selected;
            var item = "";
            var server = "";
            var item_status = 'APP1';
            var text_confirm = 'Are you sure you want to approve this items ?';
            var text_success = 'Item successfully approved';

            for(var a=0; a<arritem.length; a++){
                item += ",'"+arritem[a].REQUEST_NO+"'";
                server += ",'"+arritem[a].SERVER_CODE+"'";
            }

            item = item.substr(1);
            server = server.substr(1);                
            if(arritem.length < 1){
                alert("You haven't selected an item");
                return false;
            }
            
            if(self.item_status=='APP1'){
              item_status='APP2';

            }else if(self.item_status=='APP2'){
              item_status='CAT';
            }

            if(type=='NI'){
              item_status='NI';
              text_confirm = 'Are you sure you want to restore this items? ?';
              text_success = 'Item successfully returned';
            
            }else if(type=='APP' && self.item_status=='APP1'){
              url = this.base_url + 'material/submitapp';
            }

            if(type=='RJT'){
              item_status='RJT';
              text_confirm = 'Are you sure you want to reject this items ?';
              text_success = 'Item successfully rejected';
            }
            
            self.loading = true;
            self.container = false;
            
            this.$dialog.confirm({
              text: text_confirm,
              overlay:true,
              actions: {
                  false: 'No',
                  true: {
                    color: 'red',
                    text: 'Yes',
                    handle: () => {
                        this.axios.post(url , {
                            email_approval:self.email_approval,
                            user_approval:self.user_approval,
                            user_id:self.user_id,
                            username:self.user_request,
                            departement_id:self.departement_id,
                            item_status : item_status,
                            item : item,
                            server : server
                        })
                        .then(function (response) {
                            self.result = response.data;
                            if(response.data==true){
                                self.getMaterial();
                                self.selected = [];
                                alert(text_success);
                                // this.$dialog.notify.info('Item successfully submitted', {
                                //   position: 'bottom',
                                //   timeout : 2000
                                // });
                            }else{
                              alert(response.data);
                            }
                            self.loading = false;
                            self.container = true;
                        })
                        .catch(function (error) {
                            self.result = error;
                            self.loading = false;
                            self.container = true;
                        });                    
                    }
                  }
                }
            })         
        },
        getMessage(item){
            var self= this;
            self.modal_message = true;
            self.requester_message = item.MESSAGE;
            self.requester_date = item.DATE;
            self.request_no = item.REQUEST_NO;
            self.listMessage();
        },
        sendMessage(){
          var self = this;
          var url  = self.base_url + "mail/send_message";
          this.axios.post(url , {
              message : self.message,
              from : self.user_approval_request,
              request_no : self.request_no
          })
          .then(function (response) {
              if(response.data==true){
                  self.listMessage();
              }else{
                  alert(response.data);
              }
          });
        },
        listMessage(){
          var self = this;
          var url  = self.base_url + "mail/list_message";
          this.axios.post(url , {
              request_no : self.request_no
          })
          .then(function (response) {
              self.list_message = response.data;
          });
        }
    },
    mounted(){
        this.getMaterial();
    },
    data () { 
      return {
        name : "Registration",
        title : "Item Approval List",
        dialog: false,
        notifications: false,
        sound: true,
        widgets: false,
        singleSelect: false,
        selected: [],
        val:'',
        headers: [
          { text: 'Action', value: 'action', sortable: false,width:50},
          { text: 'Requester', value: 'REQUEST_BY' },
          { text: 'Request Date', value: 'DATE',width:'150' },
          { text: 'Server', value: 'SERVER_CODE',width:'130' },
          { text: 'Item Name', value: 'INC',width:'250' },
          { text: 'Additional Info', value: 'ADDITIONAL_INFORMATION',width:'250'},
          { text: 'Brand', value: 'BRAND',width:'150' },
          { text: 'Part Number', value: 'PART_NO',width:'200' },
          { text: 'Company', value: 'COMPANY_NAME',width:'250' },
          { text: 'Plant', value: 'PLANT_NAME',width:'170' },
          { text: 'Storage Location', value: 'STORAGE_LOCATION_NAME',width:'180' },
          { text: 'UOM', value: 'UOM_NAME',width:'150' },
          { text: 'Criticallity', value: 'CRITICALLITY',width:'150' },
          { text: 'Avg Usage', value: 'AVERAGE_USAGE',width:'120' },
          { text: 'Message', value: 'MESSAGE',width:'200' },
        ],
        desserts: [],
        list_message : [],
        user_id:'',
        email_approval:'imasterdevelope2@gmail.com',
        user_request:'',
        departement_id:'',
        username:'',
        user_approval_request:'',
        modal_message:false,
        requester_message:'',
        requester_date:'',
        server_approval : '',
        request_no : '',
        message:''
      }
    },
  }
</script>
